from __future__ import print_function 
import sys
import gzip
import glob
import time
import math
 # Only needed for Python 2
import numpy as np

import urllib
import ftplib
from datetime import datetime, timedelta

'''
urllib.urlretrieve(
        "ftp://ftp.wwpdb.org/pub/pdb/derived_data/index/entries.idx",
        "entries_{0}.idx".format(datetime.now().strftime('%Y-%m-%d'))
        )
'''

fileName = "/pub/pdb/derived_data/index/entries.idx"
ftp = ftplib.FTP("ftp.wwpdb.org")
ftp.login()
ftp.cwd("/pub/pdb/derived_data/index/")
modifiedTime = ftp.sendcmd('MDTM entries.idx').split(' ')[1]
strdate = datetime.strptime(modifiedTime, '%Y%m%d%H%M%S')
print(strdate)
d = timedelta(weeks=1)
delta_month = timedelta(weeks=6)
if strdate > datetime.now() - d: 
   
 start_time = time.clock()
 
 '''
 file = "/mnt/data/databases/wwpdb/pdb/00/pdb200l.ent.gz"
 inF = gzip.open(file, 'rb')
 s = inF.read()
 
 print s.split('\n')[0].spilt()
 '''
 
 subfolders = glob.glob("/mnt/data/databases/wwpdb/pdb/*")
 n=len(subfolders)
 print(n)
 
 
 
 '''for fold in subfolders:
 	files = glob.glob("{0}/*.ent.gz".format(subfolders[0]))
 print(files)'''
 
 
 strdate = str(strdate)
 
 files=[]
 
 #g=open('rerun_input.txt', 'r')
 h=open('/home/takacskristof/Amyloid_PIT_output/output_{0}.txt'.format(str(strdate.split('-')[0]+strdate.split('-')[1]+strdate.split('-')[2].split(' ')[0])), 'w+')
 i=open('/home/takacskristof/Amyloid_PIT_output/amyloid_hits_{0}.txt'.format(str(strdate.split('-')[0]+strdate.split('-')[1]+strdate.split('-')[2].split(' ')[0])), 'w+')
 
 '''for line in g:
   files.append(line.rstrip())'''
 
 #print(files)
 for m in range(0,len(subfolders)):	
  files = glob.glob("{0}/*.ent.gz".format(subfolders[m]))
  #print(files)
  for fil in files:
   print(m)
   print(fil)
   f = gzip.open(fil, 'rb')
   firstline=f.readlines(0)[0]  
   #print(firstline)
   depos_date=firstline[50:59]
   #print("depos_date: ", depos_date)
   print("depos_date.split('-')[2]: ", depos_date.split('-')[2])
   if int(depos_date.split('-')[2])<20:
    century=20
   else:
    century=19
   if depos_date.split('-')[1]=="JAN":
    month="January"
   if depos_date.split('-')[1]=="FEB": 
    month="February"
   if depos_date.split('-')[1]=="MAR": 
    month="March"
   if depos_date.split('-')[1]=="APR": 
    month="April"
   if depos_date.split('-')[1]=="MAY": 
    month="May"
   if depos_date.split('-')[1]=="JUN": 
    month="June"
   if depos_date.split('-')[1]=="JUL": 
    month="July"
   if depos_date.split('-')[1]=="AUG": 
    month="August"
   if depos_date.split('-')[1]=="SEP": 
    month="September"
   if depos_date.split('-')[1]=="OCT": 
    month="October"
   if depos_date.split('-')[1]=="NOV": 
    month="November"
   if depos_date.split('-')[1]=="DEC": 
    month="December"
   mod_depos_date0=depos_date.split('-')[0] + " " + str(month) + ", " + str(century) + depos_date.split('-')[2]
   print(mod_depos_date0)
   mod_depos_date = datetime.strptime(mod_depos_date0, '%d %B, %Y')
   if mod_depos_date<datetime.now()-delta_month:
    continue  
   chains=[]
   mean_angles=[]
   amyloid_flag = []
   maxdiff=1.5   
   am_limit = 0.49
   main_frag=[]
   
   for line in f:
    if line[0:6] == 'ENDMDL':
     break
    if line[0:4]=='ATOM':
     chains.append(line[21])
     if len(chains)>1 and chains[-1] == chains[-2]:
     	del chains[-1]
   f.close()
   print(chains)
   if len(chains)==1:
     print("single chain")
     print(fil, ': single chain', file=h)
   elif len(chains)==0:
     print("HETATM")
     print(fil, ': HETATM', file=h)
   else:
    sheets=[]
    f = gzip.open(fil, 'rb')
    for i in range(0,len(chains)):
     sheets0=[]  
     for line in f:  
      if line[0:5]=='SHEET' and line[21]==chains[i]:
        sheets0.append(line[23:26])
        sheets0.append(line[34:37])
     f.seek(0)
     print(sheets0)
     sheets.append(sheets0)
    print(sheets)
    sheet_lengths=[]
    for i in range(0,len(sheets)):
     S=0
     for j in xrange(0,len(sheets[i]),2):
      	S=S+float(sheets[i][j+1])-float(sheets[i][j])
     sheet_lengths.append(S+1)
    print(sheet_lengths)
    sheet_lengths_sum=0
    for i in range(0,len(sheet_lengths)):
     sheet_lengths_sum=sheet_lengths_sum+sheet_lengths[i]
    print(sheet_lengths_sum) 
    for i in range(0, len(chains)-1):
      for j in range(i+1, len(chains)):		
  		  #print i,j
        CA_dist = []
        CA0_list = []
        CA1_list = []
        chain0_x = []
        chain0_y = []
        chain0_z = []
        chain1_x = []
        chain1_y = []
        chain1_z = []
        CA00_list=[]
        chain0_x0=[]
        chain0_y0=[]
        chain0_z0=[]
        CA10_list=[]
        chain1_x0=[]
        chain1_y0=[]
        chain1_z0=[]
        CA0_list_joined = []
        CA1_list_joined = []
        chain0_x_joined = []
        chain0_y_joined = []
        chain0_z_joined = []
        chain1_x_joined = []
        chain1_y_joined = []
        chain1_z_joined = []
        frags=[]
        f = gzip.open(fil, 'rb')
        for line in f:
         if line[0:6] == 'ENDMDL':
          break
         '''if line[0:6]=='HEADER':
          print(line)
          break '''
         if line[0:4]=='ATOM' and line[13:15] == 'CA' and line[21]==chains[i] and float(sheet_lengths_sum)/float(len(chains))>=4:
          ident=line[23:26]
          isum=0
          for k in xrange(0,len(sheets[i]),2):
           if len(CA00_list)==0:
            if ident>=sheets[i][k] and ident<=sheets[i][k+1]:
             CA00_list.append(line[23:26])
             chain0_x0.append(line[30:38])
             chain0_y0.append(line[38:46])
             chain0_z0.append(line[46:54])
             CA0_list_joined.append(line[23:26])
             chain0_x_joined.append(line[30:38])
             chain0_y_joined.append(line[38:46])
             chain0_z_joined.append(line[46:54])
           else:
            if ident>=sheets[i][k] and ident<=sheets[i][k+1]:
             if CA00_list[-1]>=sheets[i][k] and CA00_list[-1]<=sheets[i][k+1]:
              CA00_list.append(line[23:26])
              chain0_x0.append(line[30:38])
              chain0_y0.append(line[38:46])
              chain0_z0.append(line[46:54])
              CA0_list_joined.append(line[23:26])
              chain0_x_joined.append(line[30:38])
              chain0_y_joined.append(line[38:46])
              chain0_z_joined.append(line[46:54])
             else: 
              CA0_list.append(CA00_list)
              chain0_x.append(chain0_x0)
              chain0_y.append(chain0_y0)
              chain0_z.append(chain0_z0)
              CA00_list=[]
              chain0_x0=[]
              chain0_y0=[]
              chain0_z0=[]
              CA00_list.append(line[23:26])
              chain0_x0.append(line[30:38])
              chain0_y0.append(line[38:46])
              chain0_z0.append(line[46:54])
              CA0_list_joined.append(line[23:26])
              chain0_x_joined.append(line[30:38])
              chain0_y_joined.append(line[38:46])
              chain0_z_joined.append(line[46:54])
          if len(CA00_list)>0:
           CA0_list.append(CA00_list)
          if len(chain0_x0)>0:
           chain0_x.append(chain0_x0)
          if len(chain0_y0)>0:
           chain0_y.append(chain0_y0)
          if len(chain0_z0)>0:
           chain0_z.append(chain0_z0)
         if line[0:4]=='ATOM' and line[13:15] == 'CA' and line[21]==chains[j] and float(sheet_lengths_sum)/float(len(chains))>=4:
          ident=line[23:26]
          jsum=0
          for k in xrange(0,len(sheets[j]),2):
           if len(CA10_list)==0:
            if ident>=sheets[j][k] and ident<=sheets[j][k+1]:
             CA10_list.append(line[23:26])
             chain1_x0.append(line[30:38])
             chain1_y0.append(line[38:46])
             chain1_z0.append(line[46:54])
             CA1_list_joined.append(line[23:26])
             chain1_x_joined.append(line[30:38])
             chain1_y_joined.append(line[38:46])
             chain1_z_joined.append(line[46:54])
           else:
            if ident>=sheets[j][k] and ident<=sheets[j][k+1]:
             if CA10_list[-1]>=sheets[j][k] and CA10_list[-1]<=sheets[j][k+1]:
              CA10_list.append(line[23:26])
              chain1_x0.append(line[30:38])
              chain1_y0.append(line[38:46])
              chain1_z0.append(line[46:54])
              CA1_list_joined.append(line[23:26])
              chain1_x_joined.append(line[30:38])
              chain1_y_joined.append(line[38:46])
              chain1_z_joined.append(line[46:54])
             else: 
              CA1_list.append(CA10_list)
              chain1_x.append(chain1_x0)
              chain1_y.append(chain1_y0)
              chain1_z.append(chain1_z0)
              CA10_list=[]
              chain1_x0=[]
              chain1_y0=[]
              chain1_z0=[]
              CA10_list.append(line[23:26])
              chain1_x0.append(line[30:38])
              chain1_y0.append(line[38:46])
              chain1_z0.append(line[46:54])
              CA1_list_joined.append(line[23:26])
              chain1_x_joined.append(line[30:38])
              chain1_y_joined.append(line[38:46])
              chain1_z_joined.append(line[46:54])
          if len(CA10_list)>0:
           CA1_list.append(CA10_list)
          if len(chain1_x0)>0:
           chain1_x.append(chain1_x0)
          if len(chain1_y0)>0:
           chain1_y.append(chain1_y0)
          if len(chain1_z0)>0:
           chain1_z.append(chain1_z0)
          
          '''for k in xrange(0,len(sheets[j]),2):
           if ident>=sheets[j][k] and ident<=sheets[j][k+1]:
            jsum=jsum+1
          if jsum>0:
           CA1_list.append(line[6:11])
           chain1_x.append(line[30:38])
           chain1_y.append(line[38:46])
           chain1_z.append(line[46:54])'''
        f.close()
        '''print("chain0_x:")
        print(chain0_x)
        print("chain0_x_joined:")
        print(chain0_x_joined)'''
        '''lenchain0=0
        for k in range(0,len(chain0_x)):
         lenchain0=lenchain0+len(chain0_x[k])
        print(lenchain0)'''
        #print(chain1_x)
        #print(chain0_y)
        #print(chain0_z) 
        minlen=round(len(chain0_x_joined)/7.,0)
        if len(chain0_x)==0 or len(chain1_x)==0:
          main_frag.append((chains[i],chains[j],0))
          break
        else:
          angles0=[]
          for k in range(0,len(chain0_x)):
           for l in range(0,len(chain0_x[k])-2):
            v0_x=float(chain0_x[k][l])-float(chain0_x[k][l+1])
            v0_y=float(chain0_y[k][l])-float(chain0_y[k][l+1])
            v0_z=float(chain0_z[k][l])-float(chain0_z[k][l+1])
            v1_x=float(chain0_x[k][l+2])-float(chain0_x[k][l+1])
            v1_y=float(chain0_y[k][l+2])-float(chain0_y[k][l+1])
            v1_z=float(chain0_z[k][l+2])-float(chain0_z[k][l+1])
            if v0_x==0 and v0_y==0 and v0_z==0 or v1_x==0 and v1_y==0 and v1_z==0:
             continue
            else:
             v0_mag=(v0_x**2+v0_y**2+v0_z**2)**0.5
             v0_x_norm=float(v0_x)/float(v0_mag)
             v0_y_norm=float(v0_y)/float(v0_mag)
             v0_z_norm=float(v0_z)/float(v0_mag)
             v1_mag=(v1_x**2+v1_y**2+v1_z**2)**0.5
             #print(v1_mag)
             v1_x_norm=float(v1_x)/float(v1_mag)
             v1_y_norm=float(v1_y)/float(v1_mag)
             v1_z_norm=float(v1_z)/float(v1_mag)
             res=v0_x_norm*v1_x_norm+v0_y_norm*v1_y_norm+v0_z_norm*v1_z_norm
             angle=math.degrees(math.acos(res))
             angles0.append(angle)
          #print(angles0)
          if len(angles0)==0:
           mean_angles.append(0)
          else:
           mean_angles.append(np.mean(angles0))
          angles1=[]
          #print("chain1_x:")
          #print(chain1_x)
          #print("chain1_y:")
          #print(chain1_y)
          for k in range(0,len(chain1_x)):
           for l in range(0,len(chain1_x[k])-2):
            v0_x=float(chain1_x[k][l])-float(chain1_x[k][l+1])
            v0_y=float(chain1_y[k][l])-float(chain1_y[k][l+1])
            v0_z=float(chain1_z[k][l])-float(chain1_z[k][l+1])
            v1_x=float(chain1_x[k][l+2])-float(chain1_x[k][l+1])
            v1_y=float(chain1_y[k][l+2])-float(chain1_y[k][l+1])
            v1_z=float(chain1_z[k][l+2])-float(chain1_z[k][l+1])
            if v0_x==0 and v0_y==0 and v0_z==0 or v1_x==0 and v1_y==0 and v1_z==0:
             continue
            else:
             v0_mag=(v0_x**2+v0_y**2+v0_z**2)**0.5
             v0_x_norm=float(v0_x)/float(v0_mag)
             v0_y_norm=float(v0_y)/float(v0_mag)
             v0_z_norm=float(v0_z)/float(v0_mag)
             v1_mag=(v1_x**2+v1_y**2+v1_z**2)**0.5
             #print(v1_mag)
             v1_x_norm=float(v1_x)/float(v1_mag)
             v1_y_norm=float(v1_y)/float(v1_mag)
             v1_z_norm=float(v1_z)/float(v1_mag)
             res=v0_x_norm*v1_x_norm+v0_y_norm*v1_y_norm+v0_z_norm*v1_z_norm
             angle=math.degrees(math.acos(res))
             angles1.append(angle)
          #print(angles1)
          if len(angles1)==0:
           mean_angles.append(0)
          else:
           mean_angles.append(np.mean(angles1))         
          for k in range (0,len(chain0_x_joined)):
      			CA_dist0=[]
      			for l in range(0, len(chain1_x_joined)):
      				CA_dist0.append(((float(chain1_x_joined[l])-float(chain0_x_joined[k]))**2+(float(chain1_y_joined[l])-float(chain0_y_joined[k]))**2+(float(chain1_z_joined[l])-float(chain0_z_joined[k]))**2)**(0.5))
      			#print CA_dist0
      			if min(CA_dist0)<2 or min(CA_dist0)>15:
      				CA_dist.append(-1)
      			else:
      				CA_dist.append(min(CA_dist0))
          #print i
          #print j
          for k in range (0, min(len(chain0_x_joined), len(chain1_x_joined))-1):
      			for l in range(k+1,min(len(chain0_x_joined), len(chain1_x_joined))):
      				frag=CA_dist[k:l]
      				if np.std(frag)<=maxdiff and len(frag)>=minlen and min(frag)>=0:
      					frags.append((chains[i],chains[j],k,l))
      					if len(frags)>1:
      						a=str(frags[-1])
      						b=str(frags[-2])
      						if a.split(",")[2] == b.split(",")[2]:
      							del frags[-2]
          #print "frags: " 
          #print frags
          k=0
          if len(frags)>2:
      			while k<len(frags)-1:
      				l=min(k+1,len(frags)-1)
      				while str(frags[k]).split(",")[3]==str(frags[l]).split(",")[3] and l==k+1:
      					
      					del frags[l]
      					l=min(k+1,len(frags)-1)
      				k=k+1        
          intervals=[]
          for k in range(0, len(frags)):
      			intervals.append(frags[k][2:4])
          lengths=[]
          for k in range(0, len(intervals)):
      			lengths.append(intervals[k][1]-intervals[k][0])
          if len(lengths)>0:		
      			main_frag.append((chains[i],chains[j],float(max(lengths))/float(len(chain1_x_joined))))
          else:
      			main_frag.append((chains[i],chains[j],0))
    
    print(main_frag)
    ratio_chains=[]
  
    for i in range(0, len(chains)):
    	ratio_list_A=[]
    	for j in range(0, len(main_frag)):
    		if main_frag[j][0]==chains[i] or main_frag[j][1]==chains[i]:
    			ratio_list_A.append(main_frag[j][2])
    	ratio_chains.append(max(ratio_list_A))
    
    print(ratio_chains)
    if len(mean_angles)==0:
     mean_angles.append(0)
    print(mean_angles)
    print(min(mean_angles))
    
    if min(ratio_chains)>=am_limit and min(mean_angles)>110:
      #g=open('output.txt', 'w')
      print('Amyloid')
      print(fil, ': 1', file=h)
      print(fil, file=i)
    else:
      #g=open('output.txt', 'w')
      if min(ratio_chains)<am_limit:
       print('Not amyloid')
       print(fil, ', min(ratio_chains): ', min(ratio_chains), '; 0',  file=h)
      else:
       print('Not amyloid')
       print(fil, ', min(mean_angles): ', min(mean_angles), '; 0',  file=h)
    
    print("--- %s seconds ---" % (time.clock() - start_time))
    
    print("END")
    
else:
 print("Nem eleg friss az adatbazis")
